<template>
  <div id="createResource">
    <CoscineHeadline :headline="$t('page.createResource.title')" />

    <!-- Navigation Tabs -->
    <b-tabs v-model="currentTab" justified class="mb-4">
      <b-tab
        v-for="(tab, index) in tabs"
        :key="index"
        :disabled="!tab.active"
        :title="tab.title"
        @click.prevent="toTab(tab)"
      />
    </b-tabs>

    <!-- Tab Content -->
    <b-row class="mb-3">
      <div class="col-sm-2" />
      <div class="col-sm-8">
        <Configuration
          v-if="currentTab === 0"
          v-model="resourceForCreation"
          :is-loading="isLoading"
          @valid="setNextTab"
          @next="next"
        />
        <ApplicationProfile
          v-else-if="currentTab === 1"
          v-model="resourceForCreation"
          :all-results-loaded="allResultsLoaded"
          :application-profile="applicationProfileDefinition"
          :application-profiles="applicationProfiles"
          :is-loading-form-generator="isLoadingFormGenerator"
          :is-loading-results="isLoadingResults"
          @applicationProfileSearchChange="applicationProfileSearchChange"
          @reachedEndOfAPList="reachedEndOfAPList"
          @valid="setNextTab"
        />
        <ResourceMetadata
          v-else-if="currentTab === 2"
          v-model="resourceForCreation"
          :is-loading="isLoading"
          :readonly="false"
          @valid="setNextTab"
        />
        <Overview
          v-else-if="currentTab === 3"
          v-model="resourceForCreation"
          :tabs="tabs"
          :application-profile="applicationProfileDefinition"
          :is-loading-form-generator="isLoadingFormGenerator"
          @back="back"
          @toTab="toTab"
          @waitingForResponse="isWaitingForResponse = $event"
        />

        <b-form-group v-if="currentTab > 0 && currentTab < tabs.length - 1">
          <!-- Button Back -->
          <b-button variant="outline-primary" @click.prevent="back">
            {{ $t("buttons.back") }}
          </b-button>

          <!-- Button Next -->
          <b-button
            class="float-end"
            variant="outline-primary"
            :disabled="!tabs[currentTab + 1].active"
            @click.prevent="next"
          >
            {{ $t("buttons.next") }}
          </b-button>
        </b-form-group>
      </div>
      <div class="col-sm-2" />
    </b-row>

    <!-- Loading Spinner on Submit -->
    <LoadingSpinner :is-waiting-for-response="isWaitingForResponse" />
  </div>
</template>

<script lang="ts">
// import the store for current module
import useResourceStore from "../store";
import useProjectStore from "@/modules/project/store";
import Configuration from "../components/create-resource/Configuration.vue";
import ResourceMetadata from "../components/create-resource/ResourceMetadata.vue";
import ApplicationProfile from "../components/create-resource/ApplicationProfile.vue";
import Overview from "../components/create-resource/Overview.vue";
import type { Dataset } from "@rdfjs/types";
import type { ResourceCreationTab } from "../types";
import type {
  ApplicationProfileDto,
  ApplicationProfileForResourceCreationDto,
  DisciplineForResourceManipulationDto,
  ProjectDto,
  ResourceForCreationDto,
  ResourceTypeOptionsForCreationDto,
  VisibilityForResourceManipulationDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  components: { Configuration, ResourceMetadata, ApplicationProfile, Overview },
  setup() {
    const projectStore = useProjectStore();
    const resourceStore = useResourceStore();

    return { projectStore, resourceStore };
  },

  data() {
    return {
      allResultsLoaded: false,
      apPageNumber: 1,
      currentTab: 0,
      tabsStatus: [true, false, false, false],
      resourceForCreation: {
        description: "",
        displayName: "",
        fixedValues: {},
        name: "",
        keywords: [] as string[],
        usageRights: "",
        disciplines: [] as DisciplineForResourceManipulationDto[],
        visibility: {} as VisibilityForResourceManipulationDto,
        applicationProfile: {
          uri: "",
        } as ApplicationProfileForResourceCreationDto,
        resourceTypeId: "",
        resourceTypeOptions: {} as ResourceTypeOptionsForCreationDto,
      } as ResourceForCreationDto,
      applicationProfileDefinition: null as Dataset | null,
      applicationProfiles: [] as ApplicationProfileDto[],
      isLoadingFormGenerator: false,
      isWaitingForResponse: false,
      isLoading: false,
      isLoadingResults: false,
      searchTerm: "",
    };
  },

  computed: {
    project(): ProjectDto | null {
      return this.projectStore.currentProject;
    },
    tabs(): ResourceCreationTab[] {
      // Order does matter
      return [
        {
          title: this.$t("page.createResource.configuration.title").toString(),
          active: true,
          step: "configuration",
          hidden: false,
        },
        {
          title: this.$t(
            "page.createResource.applicationProfile.title",
          ).toString(),
          active: this.tabsStatus[1],
          step: "applicationProfile",
          hidden: false,
        },
        {
          title: this.$t(
            "page.createResource.resourceMetadata.title",
          ).toString(),
          active: this.tabsStatus[2],
          step: "resourceMetadata",
          hidden: false,
        },
        {
          title: this.$t("page.createResource.overview.title").toString(),
          active: this.tabsStatus[3],
          step: "overview",
          hidden: false,
        },
      ] as ResourceCreationTab[];
    },
  },

  watch: {
    project() {
      if (this.project && this.project.id) {
        this.isLoadingFormGenerator = false;
      }
    },
    "resourceForCreation.applicationProfile.uri"(newValue, _oldValue) {
      if (newValue) {
        this.getApplicationProfile();
      }
    },
    searchTerm() {
      this.applicationProfiles = [];
      this.apPageNumber = 1;
      this.getApplicationProfiles();
    },
  },

  async created() {
    this.isLoading = true;
    this.getApplicationProfiles();
    await this.fetchData();
    this.isLoading = false;
  },

  methods: {
    async fetchData() {
      // Load Resource Type Quotas for the project if not present
      if (this.projectStore.currentResourceTypesQuotas === null) {
        await this.projectStore.retrieveResourceTypeQuotas(this.project);
      }
      // Load list of Available Resource Types for the project if not present
      if (this.resourceStore.enabledResourceTypes === null) {
        await this.resourceStore.retrieveAvailableResourceTypesInformationForProject(
          this.project,
        );
      }
      // Load Project Visibilities if not present
      if (this.projectStore.visibilities === null) {
        await this.projectStore.retrieveVisibilities();
      }
      // Load Project Disciplines if not present
      if (this.projectStore.disciplines === null) {
        await this.projectStore.retrieveDisciplines();
      }
      // Load Project Licenses if not present
      if (this.projectStore.licenses === null) {
        await this.projectStore.retrieveLicenses();
      }
    },
    async getApplicationProfiles() {
      this.isLoadingResults = true;
      const applicationProfilesObject =
        await this.resourceStore.getApplicationProfiles(
          "uri asc, displayName asc",
          this.searchTerm,
          this.apPageNumber,
        );
      this.apPageNumber++;
      if (applicationProfilesObject) {
        this.applicationProfiles = [
          ...this.applicationProfiles,
          ...applicationProfilesObject.applicationProfiles,
        ];
        this.allResultsLoaded = applicationProfilesObject.allResultsLoaded;
      }
      this.isLoadingResults = false;
    },
    async getApplicationProfile() {
      if (this.resourceForCreation?.applicationProfile) {
        this.isLoadingFormGenerator = true;
        const applicationProfile =
          await this.resourceStore.getApplicationProfile(
            this.resourceForCreation.applicationProfile.uri,
          );
        this.applicationProfileDefinition = applicationProfile.definition;
        this.isLoadingFormGenerator = false;
      } else {
        this.applicationProfileDefinition = null;
      }
    },
    reachedEndOfAPList() {
      this.getApplicationProfiles();
    },
    applicationProfileSearchChange(searchTerm: string) {
      this.searchTerm = searchTerm;
    },
    back() {
      this.currentTab -= 1;
    },
    next() {
      this.currentTab += 1;
    },
    toTab(tab: ResourceCreationTab) {
      this.currentTab = this.tabs.findIndex((t) => t.step === tab.step);
    },
    setNextTab(active: boolean) {
      // TODO: check reactivity
      this.tabsStatus[this.currentTab + 1] = active;
    },
  },
});
</script>
